import chalib
from Splitter import Splitter as BaseSplitter
from ExtensionClass import Base
from string import split, join
import thread
import perl

jsplitter_lock=thread.allocate_lock()

# We get part-of-speech codes back from chalib which we then use to
#  judge which words to index.  Run 'chasen -lp' to get a list of
#  codes.  This list is of the codes for parts-of-speech we want to
#  keep.
keepcodes=range(1,13) + range(16,25) + \
           [36, 37, 38, 44, 45, 48, 49, 52, 53, 54, 55, 72, 78, 82, 84]

class Splitter(Base, BaseSplitter):
    """ First try at a Japanese-capable Splitter. """

    # default for older objects
    stop_syn={}

    def __init__(self, doc, stop_syn=None, encoding='latin1'):
        if stop_syn is None:
            self.stop_syn = {}
        else:
            self.stop_syn = stop_syn
        self.encoding = encoding
        
        perl.eval("use Jcode")
	doc=perl.callm("new","Jcode").set(doc).euc()
        
        jsplitter_lock.acquire() # chalib is not thread-safe
        c=split(chalib.sparse_tostr(doc, "%M\t%h\n"), '\n')
        jsplitter_lock.release()
        
        c=filter(lambda x: x != 'EOS' and x != '', c)
        d=[]
        for i in c:
            word, code=split(i, '\t')
            if int(code) in keepcodes:
                d.append(word)
        text=join(d, ' ')
        BaseSplitter.__init__(self, text, self.stop_syn)
